﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	

	public class Zoomer extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		private var cloned:BitmapData;
		private var upground:Bitmap;
		private var counter:Number = 0;
		public function Zoomer()
		{
				addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			setup();
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			while(numChildren>0){
				this.removeChildAt(0);
			}
			data = null;
			
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			background = new Bitmap(data);
			addChild(background);
		}
		
		private function down_handler(e:MouseEvent):void
		{
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function up_handler(e:MouseEvent):void
		{
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			setup();
		}
		
		private function enterHandler(e:Event):void
		{
			if(data == null){
				setup();
			}
			if(counter>100){
				counter = 0;
			}else{
				counter++;
			}
			var my_drawer:Sprite = buildDrawer();
			var support:Sprite = new Sprite();
			my_drawer.x = mouseX;
			my_drawer.y = mouseY;
			my_drawer.scaleX=my_drawer.scaleY=0.1;
			support.addChild(my_drawer);
			data.draw(support);
			cloned = data.clone();
			var mul:uint = 0x2;
			data.merge(cloned,new Rectangle(0,0,stage.stageWidth,stage.stageHeight),new Point(counter,counter-10),mul,mul,mul,mul);
			
		}
		private function buildDrawer():Sprite
		{
			drawer = new Sprite();
			drawer.graphics.beginFill(0x948394,.9);
			drawer.graphics.drawCircle(10,20,200);
			drawer.graphics.endFill();
			drawer.rotation = Math.random()*90;
			return drawer;
		}
		
	}
}